/*
 * tmos - kmem.c
 * Copyright (C) 2010  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Fundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <tmos/kernel.h>
#include <tmos/port.h>
#include <tmos/errno.h>

#if KERNEL_TASK_SIZE > OFF_MAX
#define KMEM_SIZE	OFF_MAX
#else 
#define KMEM_SIZE	KERNEL_TASK_SIZE
#endif

msg_ssize_t dev_kmem_read(port_t port, char __kernel *buf,
		msg_size_t len, off_t off)
	__reentrant
{
	if (len > KMEM_SIZE - off)
		len = KMEM_SIZE - off;
	memcpy(buf, (void __kernel *) off, len);
	return len;
}
